# Install a Minecraft Server

Aktualisiere dein Debian System auf die neueste Version.

```
sudo apt update

sudo apt upgrade
```

## Java installieren

```
sudo apt install openjdk-17-jdk openjdk-17-jre
```

Check the version

```
java -version
```

You should get something like this as output:

```
openjdk 17.0.2 2022-01-18
OpenJDK Runtime Environment (build 17.0.2+8-Ubuntu-120.04)
OpenJDK 64-Bit Server VM (build 17.0.2+8-Ubuntu-120.04, mixed mode, sharing
```

## Minecraft installieren

Make a new folder & go to that folder

```
mkdir minecraft && cd minecraft
```

Download the newest version of Spigot from [Spigot Download](https://getbukkit.org/download/spigot)

```
wget https://download.getbukkit.org/spigot/spigot-1.19.2.jar
```

rename the spigot-{version}.jar

```
mv spigot-1.19.2.jar server.jar
```

## Create the Startup-Script

```
nano start.sh
```

Write the following in the file:

```
java -Xms2048M -Xmx2048M -jar server.jar nogui
```

## Make start.sh exec

```
sudo chmod +x start.sh
```

## Run the server

```
./start.sh
```

## Commands

```
whitelist add {Username}
op {Username}
```
